#include "KMotionDef.h"

#define SpindlePosition 36
#define SpindleHoming 37

main()
{


	ch0->SoftLimitPos=990666;
	ch0->SoftLimitNeg=-990666;

	ch1->SoftLimitPos=91333333;
	ch1->SoftLimitNeg=-9133333;

	ch2->SoftLimitPos=9999990;
	ch2->SoftLimitNeg=-9317440;
	

	int i;
	int t0;
	int NoiseFilter;
	int NoiseCounter;
	double filter;
	int filterqty;
	int StopLoop;
	double pulsepermmX;
	double pulsepermmY;
	double pulsepermmZ;
	double pulsepermmA;
	int BitX;
	int BitY;
	int BitZ;
	int BitZe;
	int BitA;
	int BitAe;
	
	int inputX;
	int inputY;
	int inputZ;
	int inputA;
	
	double hx1 = 0;
	double hx2 = 0;
	double hx3 = 0;
	double hx4 = 0;
	double hx5 = 0;
	double hxmean = 0;


	double hy1 = 0;
	double hy2 = 0;
	double hy3 = 0;
	double hy4 = 0;
	double hy5 = 0;
	double hymean = 0;


	double hz1 = 0;
	double hz2 = 0;
	double hz3 = 0;
	double hz4 = 0;
	double hz5 = 0;
	double hzmean = 0;
	
	double ha1 = 0;
	double ha2 = 0;
	double ha3 = 0;
	double ha4 = 0;
	double ha5 = 0;
	double hamean = 0;

	
	BitX = 20;
	BitY = 21;
	BitZ = 25;
	BitZe = 6;
	BitA = 7;
	BitAe = 44;
	
	
	SetBitDirection(BitX,0);// set IO20 as input	
	SetBitDirection(BitY,0);// set IO21 as input
	SetBitDirection(BitZ,0);// set IO25 as input	
	SetBitDirection(BitA,0);// set IO7 as input
	SetBitDirection(17,1);// set IO17 as output - brake of Z axis
	SetBitDirection(SpindlePosition,1);
	SetBitDirection(SpindleHoming,1); 
	
	
	filter=0.001;
	filterqty=100;
	inputX=ReadBit(BitX);
	inputY=ReadBit(BitY);
	inputZ=ReadBit(BitZ);	
	inputA=ReadBit(BitA);
	
	pulsepermmX=533.3333333;
	pulsepermmY=533.3333333;
	pulsepermmZ=250;  //  533.3333333
	pulsepermmA=5000;
	
	
	// disable the limits (first save how they were set) 
	//SaveYLimits = ch0->LimitSwitchOptions;
	//SaveXLimits = ch1->LimitSwitchOptions;
	//SaveZLimits = ch2->LimitSwitchOptions;
	//ch0->LimitSwitchOptions = 0;
	//ch1->LimitSwitchOptions = 0;
	//ch2->LimitSwitchOptions = 0;
	
	SetBit(17);
	
	goto label;
	
	//----------------Homing X-----------------
	
	WaitNextTimeSlice();	
	
	StopLoop = 0;
	Jog(1,10000);          // start moving
	while (!StopLoop) { // wait for switch (input BitX) to go TRUE for 100*filter
		StopLoop = 0;	
		if(ReadBit(BitX)) {	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter < filterqty) {
				Delay_sec(filter);
				NoiseCounter++;
				if(ReadBit(BitX)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}
	StopLoop = 0;	
	
	
	Jog(1,-200);			// return to turn off sensor
	while (!StopLoop) { 		// wait for switch (input BitX) to go FALSE for 100*filter
		StopLoop = 0;	
		if(!ReadBit(BitX)) {	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter < filterqty) {
				Delay_sec(filter);
				NoiseCounter++;
				if(!ReadBit(BitX)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}
	StopLoop = 0;
	hx1=ch1->Dest;
	Jog(1,0);		      	// stop	
	while(!CheckDone(1));
	printf("1er %f \n");
	
	
	
	Jog(1,5000);          // start moving
	while (!StopLoop){ // wait for switch (input BitX) to go TRUE for 100*filter
		StopLoop = 0;	
		if(ReadBit(BitX)){	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter<filterqty){
				Delay_sec(filter);
				NoiseCounter++;
				if(ReadBit(BitX)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}
	StopLoop = 0;	
	
	
	Jog(1,-200);			// return to turn off sensor
	while (!StopLoop) { 		// wait for switch (input BitX) to go FALSE for 100*filter
		StopLoop = 0;	
		if(!ReadBit(BitX)) {	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter < filterqty) {
				Delay_sec(filter);
				NoiseCounter++;
				if(!ReadBit(BitX)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}
	StopLoop = 0;
	hx2=ch1->Dest;
	Jog(1,0);		      	// stop	
	while(!CheckDone(1));
	printf("2eme %f \n");


	Jog(1,5000);          // start moving
	while (!StopLoop){ // wait for switch (input BitX) to go TRUE for 100*filter
		StopLoop = 0;	
		if(ReadBit(BitX)){	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter<filterqty){
				Delay_sec(filter);
				NoiseCounter++;
				if(ReadBit(BitX)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}
	StopLoop = 0;	
	
	
	Jog(1,-200);			// return to turn off sensor
	while (!StopLoop) { 		// wait for switch (input BitX) to go FALSE for 100*filter
		StopLoop = 0;	
		if(!ReadBit(BitX)) {	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter < filterqty) {
				Delay_sec(filter);
				NoiseCounter++;
				if(!ReadBit(BitX)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}
	StopLoop = 0;
	hx3=ch1->Dest;
	Jog(1,0);		      	// stop	
	while(!CheckDone(1));
	
	
	
	
	Jog(1,5000);          // start moving
	while (!StopLoop){ // wait for switch (input BitX) to go TRUE for 100*filter
		StopLoop = 0;	
		if(ReadBit(BitX)){	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter<filterqty){
				Delay_sec(filter);
				NoiseCounter++;
				if(ReadBit(BitX)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}	
	StopLoop = 0;	
	
	
	Jog(1,-200);			// return to turn off sensor
	while (!StopLoop) { 		// wait for switch (input BitX) to go FALSE for 100*filter
		StopLoop = 0;	
		if(!ReadBit(BitX)) {	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter < filterqty) {
				Delay_sec(filter);
				NoiseCounter++;
				if(!ReadBit(BitX)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}
	StopLoop = 0;
	hx4=ch1->Dest;
	Jog(1,0);		      	// stop	
	while(!CheckDone(1));
	
	
	
	
	Jog(1,5000);          // start moving
	while (!StopLoop){ // wait for switch (input BitX) to go TRUE for 100*filter
		StopLoop = 0;	
		if(ReadBit(BitX)){	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter<filterqty){
				Delay_sec(filter);
				NoiseCounter++;
				if(ReadBit(BitX)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}
	StopLoop = 0;	
	
	
	Jog(1,-200);			// return to turn off sensor
	while (!StopLoop) { 		// wait for switch (input BitX) to go FALSE for 100*filter
		StopLoop = 0;	
		if(!ReadBit(BitX)) {	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter < filterqty) {
				Delay_sec(filter);
				NoiseCounter++;
				if(!ReadBit(BitX)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}
	StopLoop = 0;
	hx5=ch1->Dest;
	Jog(1,0);		      	// stop	
	while(!CheckDone(1));
	

	hxmean=((hx1+hx2+hx3+hx4+hx5-maximum(hx1,hx2,hx3,hx4,hx5)-minimum(hx1,hx2,hx3,hx4,hx5))/3);
	printf(" hx1 %f \n", hx1);
	printf("%f \n", hx2);
	printf("%f \n", hx3);
	printf("%f \n", hx4);
	printf("%f \n", hx5);
	
	printf("%f \n", hxmean);
	
	MoveAtVel(1,hxmean,-200);
	while(!CheckDone(1));
	Zero(1);
	MoveAtVel(1,-242*pulsepermmX,10000);
	while(!CheckDone(1));
	Zero(1);

//---------------------Homing Y----------------------


	Jog(0,5000);          // start moving
	while (!StopLoop){ // wait for switch (input BitY) to go TRUE for 100*filter
		StopLoop = 0;	
		if(ReadBit(BitY)){	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter<filterqty){
				Delay_sec(filter);
				NoiseCounter++;
				if(ReadBit(BitY)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}
	StopLoop = 0;	
	
	
	Jog(0,-200);			// return to turn off sensor
	while (!StopLoop) { 		// wait for switch (input BitY) to go FALSE for 100*filter
		StopLoop = 0;	
		if(!ReadBit(BitY)) {	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter < filterqty) {
				Delay_sec(filter);
				NoiseCounter++;
				if(!ReadBit(BitY)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}
	StopLoop = 0;
	hy1=ch0->Dest;
	Jog(0,0);		      	// stop	
	while(!CheckDone(0));
	
	
	Jog(0,5000);          // start moving
	while (!StopLoop){ // wait for switch (input BitY) to go TRUE for 100*filter
		StopLoop = 0;	
		if(ReadBit(BitY)){	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter<filterqty){
				Delay_sec(filter);
				NoiseCounter++;
				if(ReadBit(BitY)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}
	StopLoop = 0;	
	
	
	Jog(0,-200);			// return to turn off sensor
	while (!StopLoop) { 		// wait for switch (input BitY) to go FALSE for 100*filter
		StopLoop = 0;	
		if(!ReadBit(BitY)) {	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter < filterqty) {
				Delay_sec(filter);
				NoiseCounter++;
				if(!ReadBit(BitY)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}
	StopLoop = 0;
	hy2=ch0->Dest;
	Jog(0,0);		      	// stop	
	while(!CheckDone(0));
	

	Jog(0,5000);          // start moving
	while (!StopLoop){ // wait for switch (input BitY) to go TRUE for 100*filter
		StopLoop = 0;	
		if(ReadBit(BitY)){	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter<filterqty){
				Delay_sec(filter);
				NoiseCounter++;
				if(ReadBit(BitY)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}
	StopLoop = 0;	
	
	
	Jog(0,-200);			// return to turn off sensor
	while (!StopLoop) { 		// wait for switch (input BitY) to go FALSE for 100*filter
		StopLoop = 0;	
		if(!ReadBit(BitY)) {	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter < filterqty) {
				Delay_sec(filter);
				NoiseCounter++;
				if(!ReadBit(BitY)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}
	StopLoop = 0;
	hy3=ch0->Dest;
	Jog(0,0);		      	// stop	
	while(!CheckDone(0));
	
	
	Jog(0,5000);          // start moving
	while (!StopLoop){ // wait for switch (input BitY) to go TRUE for 100*filter
		StopLoop = 0;	
		if(ReadBit(BitY)){	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter<filterqty){
				Delay_sec(filter);
				NoiseCounter++;
				if(ReadBit(BitY)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}
	StopLoop = 0;	
	
	
	Jog(0,-200);			// return to turn off sensor
	while (!StopLoop) { 		// wait for switch (input BitY) to go FALSE for 100*filter
		StopLoop = 0;	
		if(!ReadBit(BitY)) {	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter < filterqty) {
				Delay_sec(filter);
				NoiseCounter++;
				if(!ReadBit(BitY)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}
	StopLoop = 0;
	hy4=ch0->Dest;
	Jog(0,0);		      	// stop	
	while(!CheckDone(0));
	
	
	Jog(0,5000);          // start moving
	while (!StopLoop){ // wait for switch (input BitY) to go TRUE for 100*filter
		StopLoop = 0;	
		if(ReadBit(BitY)){	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter<filterqty){
				Delay_sec(filter);
				NoiseCounter++;
				if(ReadBit(BitY)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}
	StopLoop = 0;	
	
	
	Jog(0,-200);			// return to turn off sensor
	while (!StopLoop) { 		// wait for switch (input BitY) to go FALSE for 100*filter
		StopLoop = 0;	
		if(!ReadBit(BitY)) {	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter < filterqty) {
				Delay_sec(filter);
				NoiseCounter++;
				if(!ReadBit(BitY)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}
	StopLoop = 0;
	hy5=ch0->Dest;
	Jog(0,0);		      	// stop	
	while(!CheckDone(0));
	

	hymean=((hy1+hy2+hy3+hy4+hy5-maximum(hy1,hy2,hy3,hy4,hy5)-minimum(hy1,hy2,hy3,hy4,hy5))/3);
	printf(" hy1 %f \n", hy1);
	printf("%f \n", hy2);
	printf("%f \n", hy3);
	printf("%f \n", hy4);
	printf("%f \n", hy5);
	
	printf("%f \n", hymean);

	MoveAtVel(0,hxmean,-200);
	while(!CheckDone(0));
	Zero(0);

	MoveAtVel(0,-150*pulsepermmY,10000);
	while(!CheckDone(0));
	Zero(0);
	//----------------Homing Z-----------------
	
label:	
	
	WaitNextTimeSlice();
	
	ClearBit(SpindlePosition); 		// clear Position mode of the spindle
	SetBit(SpindleHoming);			// Set Spindle to Homing mode
	
	Delay_sec(2);
	
	ClearBit(SpindleHoming);	
	SetBit(SpindlePosition); 
	
	Delay_sec(0.5);
	
	ch4->Position=0;
    EnableAxis(2);
    MoveRelAtVel(2,100*pulsepermmZ,3000);
    printf("Z up 1");
    while(!CheckDone(2));
    	
	MoveAtVel(4, -105, 1000);
	StopLoop = 0;

	Jog(2,1000);          // start moving
	printf("Z up 2");
	filterqty = 100;
	while (!StopLoop){ // wait for switch (input BitZ) to go TRUE for 100*filter
		StopLoop = 0;	
		if(ReadBit(BitZ)){	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter<filterqty){
				Delay_sec(filter);
				NoiseCounter++;
				if(ReadBit(BitZ)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}
	StopLoop = 0;	
		
	Jog(2,0);		      	// stop	
	Zero(2);
	while(!CheckDone(2));
	Delay_sec(2);
	
	MoveAtVel(2,-1500,1000);
	
	Jog(2,-50);          // start moving

	filterqty=20;	
	WaitNextTimeSlice();
	while (!StopLoop){ // wait for switch (input BitA) to go TRUE for 100*filter
		StopLoop = 0;	
		if(ReadBit(BitZe)){	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter<filterqty){
				Delay_sec(filter);
				NoiseCounter++;
				if(ReadBit(BitZe)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}


	Jog(2,0);
	Delay_sec(5);
	Zero(2);
	MoveAtVel(2,-35*pulsepermmZ,10000);
	while(!CheckDone(2));
	MoveAtVel(4, 0, 3000);
	MoveAtVel(2,-143*pulsepermmZ,10000); //-153.72
	while(!CheckDone(2));
	Zero(2);
	
	return(0);

	//----------------Homing A-----------------
	filterqty=100;	
	WaitNextTimeSlice();

	Jog(3,50000);          // start moving
	while (!StopLoop){ // wait for switch (input BitA) to go TRUE for 100*filter
		StopLoop = 0;	
		if(ReadBit(BitA)){	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter<filterqty){
				Delay_sec(filter);
				NoiseCounter++;
				if(ReadBit(BitA)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}
	StopLoop = 0;	
	Delay_sec(0.4);
	
	Jog(3,0);			// stop
	while(!CheckDone(3));
	Zero(3);
	filter=0.001;
	
	Jog(3,-500);          // start moving

	filterqty=10;	
	WaitNextTimeSlice();
	while (!StopLoop){ // wait for switch (input BitA) to go TRUE for 100*filter
		StopLoop = 0;	
		if(!ReadBit(BitAe)){	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter<filterqty){
				//Delay_sec(filter);
				NoiseCounter++;
				if(!ReadBit(BitAe)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}


	Zero(3);
	Jog(3,0);
	while(!CheckDone(3));
	MoveAtVel(3,-263320,100000);
	while(!CheckDone(3));
	Zero(3);


	ch0->SoftLimitPos=90666;
	ch0->SoftLimitNeg=-90666;

	ch1->SoftLimitPos=1333333;
	ch1->SoftLimitNeg=-133333;

	ch2->SoftLimitPos=0;
	ch2->SoftLimitNeg=-317440;

}

double minimum(double a,double b, double c, double d, double e) 
{ 
double min; 
min=a; 
if(b<min) 
{ 
	min=b; 
} 
if(c<min) 
{ 
	min=c; 
} 
if(d<min) 
{ 
	min=d; 
} 
if(e<min) 
{ 
	min=e; 
} 

return min; 
} 


double maximum(double a,double b, double c, double d, double e) 
{ 
double max; 
max=a; 
if(b>max) 
{ 
	max=b; 
} 
if(c>max) 
{ 
	max=c; 
} 
if(d>max) 
{ 
	max=d; 
} 
if(e>max) 
{ 
	max=e; 
} 

return max; 
} 